# $Id: ssl-worm.bro,v 1.4 2003/01/16 00:28:34 vern Exp $

@load signatures
@load software
@load log

redef capture_filter +=
	"udp port 2002 and (src net 128.3 or src net 131.243)";

redef rule_actions +=  {
	["sslworm-udp2002"] = RULE_QUIET,
};

event bro_init()
	{
	set_buf(rule_file, F);
	set_buf(bro_log_file, F);
	set_buf(software_file, F);
	}

function sslworm_is_server_vulnerable(state: signature_state): bool
	{
	local ip = state$conn$id$resp_h;

	if ( ip !in software_table )
		return F;

	local softset = software_table[ip];

	if ( "Apache" !in softset )
		return F;

	if ( "OpenSSL" !in softset )
		return F;

	local safe_version: software_version =
		[$major = 0, $minor = 9, $minor2 = 6, $addl = "e"];

	if ( software_cmp_version(softset["OpenSSL"]$version, safe_version) >= 0 )
		return F;

	return T;
	}

function sslworm_has_server_been_probed(state: signature_state): bool
	{
	# FIXME: Bro segfaults without the tmp variable
	local result =
		has_signature_matched("sslworm-probe",
				state$conn$id$orig_h, state$conn$id$resp_h);

	return result;
	}

function sslworm_has_server_been_exploited(state: signature_state): bool
	{
	# FIXME: I don't know which side starts the UDP conversation
	local result =
		has_signature_matched("sslworm-exploit",
				state$conn$id$orig_h, state$conn$id$resp_h);

	if ( ! result )
		result = has_signature_matched("sslworm-exploit",
				state$conn$id$resp_h, state$conn$id$orig_h);

	return result;
	}
